final int DISPLAY_TIME = 3000;
final float MAX_ALPHA = 200.0;

//For the Framerate
int rate = 60;

//For Fading Animation
float alphi = 5.0 * MAX_ALPHA * (float)rate / DISPLAY_TIME;

int time = 0;
float alphaVal = MAX_ALPHA;
int lastTime;

//For Animation
String selectedBird = "";
int currentMonth = 0;
int current_week = 0;

void draw() {
  background(240);
  map.draw();
  
  if(millis() < 5000)
    return;
    
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0);
        
  //Draw ControlP5 GUI
  drawGUI();
    
  //Draw Name of the State that is being Hovered Over
  if (currentMarker != null) 
  {
    stroke(255, 0, 0);
    fill(255, 0, 0);
    textAlign(CENTER, CENTER);
    textFont(font1);
    text(currentMarker.getStringProperty("NAME"), width / 2, height * 0.1);
  }
  
  //////////////////////////////////////////////////////////////////////////////
  /////////////////////////// Draw Bird Count Points ///////////////////////////
  //////////////////////////////////////////////////////////////////////////////
    
  if(selectedBird != "")
  {
    if(millis() - lastTime >= DISPLAY_TIME){
      alphaVal = MAX_ALPHA;  
      lastTime = millis(); 
      current_week++;
    
      if(current_week == 48)
        current_week = 0;
    }
  
    //Title
    stroke(255, 0, 0);
    fill(255, 0, 0);
    textAlign(CENTER, CENTER);
    textFont(font2);
    text("Bird Migration Pattern for: " + selectedBird, width / 2, height * 0.03);
  
    //Print Month and Week
    stroke(255, 0, 0);
    fill(255, 0, 0);
    textAlign(CENTER, CENTER);
    textFont(font2);
    text(months[currentMonth] + ": Week " + ((current_week % 4) + 1), 
         width / 2, height * 0.06);
         
    //Draw Bird's Photo
    drawImageFromGoogle();
    
    //Draw Circles
    noStroke();
    fill(255, 0, 0, alphaVal);
  
    if(birdyData.get(selectedBird) != null)
    {
      Bird_Data tempAviData = birdyData.get(selectedBird);
    //for(int i = 0; i < 48; i++) //This is the data point
      for(int i = current_week; i < current_week + 1; i++) //This is the data point
      {
        if(i % 4 == 0 && i < 48)
        {
          println("Month: " + months[(i / 4)]);
          currentMonth = (i / 4);
        }
        
      //println("    i = " + i);
      //println("birdStateSize: " + tempAviData.bird_states.size());
        for(int j = 0; j < tempAviData.bird_states.size(); j++) //This is the state 
        {
        //println("         - " + tempAviData.bird_states.get(j) + " " + 
        //  tempAviData.weekly_bird_data.get(j).get(i));
         // println("in for loop: " + i + ", " + j);
          Location l = stateCenters.get(tempAviData.bird_states.get(j));
          float yz[] = map.getScreenPositionFromLocation(l);
          ellipse(yz[0], yz[1], tempAviData.weekly_bird_data.get(j).get(i), 
                                tempAviData.weekly_bird_data.get(j).get(i));
        }
      //println("\n");
      }
    }
    else
    {
    //println("ERROR: Data for: " + selectedBird + " has disappeared!");
    }

    alphaVal -= alphi;
  
    if (alphaVal < 0 || alphaVal > MAX_ALPHA) { 
      alphi *= -1; 
    } 
  }
  else //No Bird is Selected
  {
    stroke(255, 0, 0);
    fill(255, 0, 0);
    textAlign(CENTER, CENTER);
    textFont(font2);
    text("Bird Migration Patterns", width / 2, height * 0.03);
  }
  /*
  //Go through the birds
  for (String birdKey : dataMap.keySet()) 
  {
    println("~ BirdKey: " + birdKey + "~");
    
    //Get the states that bird has been in
    for (HashMap<String, ArrayList<Float>> birdStateVisits : dataMap.values()) 
    {     
      int numStatesVisited = birdStateVisits.keySet().size();
     
      //Makes an Array to hold the data of all the birds
      //This array is needed in order to go through the data 
      //in the order that is needed more easily
      ArrayList<ArrayList<Float>> bdata = 
         new ArrayList<ArrayList<Float>>(numStatesVisited);
      for(ArrayList<Float> fvals : birdStateVisits.values()) {
        bdata.add(fvals);
      }
     
      //Make an Array to hold the names of the states visited
      ArrayList<String> sdata = new ArrayList<String>(numStatesVisited);
      for(String st8 : birdStateVisits.keySet()) {
        sdata.add(st8);
      }
       
      //Print Bdata, we know there are 48 data points from before
      for(int y = 0; y < 48; y++)
      {
        for(int x = 0; x < bdata.size(); x++)
        {
          print(sdata.get(x) + ": ");   //This is the state
          println(bdata.get(x).get(y)); //This is the numerical data for that state
        }
        print("\n\n");
      }
    }
  }

  */
  
  
  
  
  
  
  
  
  /*
  if(millis() - lastTime >= DISPLAY_TIME ){
    alphaVal = MAX_ALPHA;  

    lastTime = millis(); 
  }  
  
  //println(alphaVal);
  noStroke();
  fill(255, 0, 0, alphaVal);
  
  for(int i = 0; i < myTable.getColumnCount() - 2; i++)
  {  
    for(int j = 0; j < states.size(); j++)
    { 
      Location l = stateCenters.get(states.get(j));
      float yz[] = map.getScreenPositionFromLocation(l);
      
      ellipse(yz[0], yz[1], dataMatrix[j][i], dataMatrix[j][i]);
    }
  }

  alphaVal -= alphi;
  
  if (alphaVal < 0 || alphaVal > MAX_ALPHA) { 
    alphi *= -1; 
  } 
  */
  
}
















  /*if(millis() > time ){
    time = millis() + 1500; 
    //alphaVal = 200.0;  
  }*/


   //(float)(time - millis)/1000.0
  //rect( 80*cos(map(millis() % 2000,0,2000,0,TWO_PI)),
  //  80*sin(map(millis() % 2000,0,2000,0,TWO_PI)), 10, 10);







  //println("X: " + mouseX + "\tY: " + mouseY);










//(float)(time - millis())/1000.0






//Old Code
  /*
  Location a = stateCenters.get("Maine");
  float yz[] = map.getScreenPositionFromLocation(a);
  ellipse(yz[0], yz[1], 5, 5);

*/




  /*for(int i = 0; i < markersList.size(); i++)
  {
    print(i + " ");
    print(markersList.get(i).getStringProperty("NAME"));
    println(markersList.get(i).getLocation());
    
    Location manyloc = markersList.get(i).getLocation();
    float xy[] = map.getScreenPositionFromLocation(manyloc);
    println(xy);

    ellipse(xy[0], xy[1], 5, 5);
  }*/
